---

- name: Gather moid for datastore
  vcenter_gather_moids:
    hostname: "{{ vault_spec.data.VCHostname }}"
    username: "{{ vault_spec.data.VCUsername }}"
    password: "{{ vault_spec.data.VCPassword }}"
    datacenter_name: "{{ datacenter }}"
    datastore_name: "{{ datastore }}"
    validate_certs: False
  register: gather_moids_ds
  tags: [ 'dlr' ]

- name: Gather moid for cluster
  vcenter_gather_moids:
    hostname: "{{ vault_spec.data.VCHostname }}"
    username: "{{ vault_spec.data.VCUsername }}"
    password: "{{ vault_spec.data.VCPassword }}"
    datacenter_name: "{{ datacenter }}"
    cluster_name: "{{ cluster }}"
    validate_certs: False
  register: gather_moids_cl
  tags: [ 'dlr' ]

- name: Gather moid for uplink
  vcenter_gather_moids:
    hostname: "{{ vault_spec.data.VCHostname }}"
    username: "{{ vault_spec.data.VCUsername }}"
    password: "{{ vault_spec.data.VCPassword }}"
    datacenter_name: "{{ datacenter }}"
    portgroup_name: "{{ uplink_ls_name }}"
    validate_certs: False
  register: gather_moids_upl_pg
  tags: [ 'dlr' ]

- name: Check/create uplink Logical switch
  nsx_logical_switch:
    nsxmanager_spec: "{{ vault_spec.data.nsxmanager_spec }}"
    state: present
    transportzone: "{{ ls_transportzone }}"
    name: "{{ uplink_ls_name }}"
    controlplanemode: "{{ uplink_ls_controlplanemode }}"
    description: "{{ uplink_ls_description }}"
  register: create_logical_switch
  tags: [ 'dlr' ]


- name: Check/create downlink Logical switch
  nsx_logical_switch:
    nsxmanager_spec: "{{ vault_spec.data.nsxmanager_spec }}"
    state: present
    transportzone: "{{ ls_transportzone }}"
    name: "{{ downlink_ls_name }}"
    controlplanemode: "{{ downlink_ls_controlplanemode }}"
    description: "{{ downlink_ls_description }}"
  register: create_logical_switch
  tags: [ 'dlr' ]


  # for the vnic definitions, typically use portgroup_id for uplink and logical_switch name for the downlink..
- name: Create the DLR
  nsx_dlr:
    nsxmanager_spec: "{{ vault_spec.data.nsxmanager_spec }}"
    state: present
    name: "{{ name }}"
    description: "{{ description }}"
    resourcepool_moid: "{{ gather_moids_cl.object_id }}"
    datastore_moid: "{{ gather_moids_ds.object_id }}"
    datacenter_moid: "{{ gather_moids_cl.datacenter_moid }}"
    mgmt_portgroup_moid: "{{ gather_moids_upl_pg.object_id }}"
    interfaces:
      - {ip: "{{ vnic0['ip'] }}", prefix_len: "{{ vnic0['prefix_len'] }}", logical_switch: "{{ uplink_ls_name }}", name: "{{ vnic0['name'] }}", iftype: "{{ vnic0['iftype'] }}", fence_param: 'ethernet0.filter1.param1=1'}
      - {ip: "{{ vnic1['ip'] }}", prefix_len: "{{ vnic1['prefix_len'] }}", logical_switch: "{{ downlink_ls_name }}", name: "{{ vnic1['name'] }}", iftype: "{{ vnic1['iftype'] }}", fence_param: 'ethernet0.filter1.param1=1'}
    routes:
      - {network: "{{ item[1].value.prefix }}, next_hop: {{ item[1].value.next_hop }}, admin_distance: {{ item[1].value.admin_distance }}, mtu: {{ item[1].value.mtu }}, description: {{ item[1].value.description }}"}
    remote_access: "{{ remote_access }}"
    username: "{{ username }}"
    password: "{{ password }}"
    ha_enabled: "{{ ha_enabled }}"
  with_nested:
    - "{{ nics }}"
    - "{{ routes }}"
  register: create_dlr
  tags: [ 'dlr' ]
  no_log: true
